/*****************************************************************
;*        Sample SFR/Vector File for TLCS-870/C1 Series          *
;*               Memory Style: Within 64K byte                   *
;*---------------------------------------------------------------*
;*  (C)Copyright TOSHIBA CORPORATION 2008  All rights reserved   *
;*****************************************************************/
//#define IO_MEM    1

#include "MQ6811.h"
__asm("public _WDTROUTINE") ;
__asm("public _WDTEND") ;
__asm("public _SWIROUTINE") ;
__asm("public _SWIEND") ;

/*
 * --------------------------------------------------------------------------
 *   VARIABLE DEFINITIONS
 * --------------------------------------------------------------------------
 */
extern unsigned int pulseWidth;
extern unsigned int cycleLength;


void startup(void);	//defined by startup.asm
/*========================================================
  [ Declare interrupt function ]
  ========================================================*/
void __interrupt Int2(void); 
void __interrupt Int3(void); 
void __interrupt Int4(void); 
void __interrupt IntTC00(void); 
void __interrupt IntTC01(void);
void __interrupt IntTC02(void);
void __interrupt IntTC03(void);
void __interrupt IntTCA0(void);
void __interrupt IntRTC(void);
void __interrupt IntADC(void);
void __interrupt IntVLTD(void);
void __interrupt IntRXD1(void);
void __interrupt IntTXD1(void);
void __interrupt IntTBT(void);
void __interrupt IntWUC(void);
void __interrupt_n IntWDT(void);  
void __interrupt_n IntSWI(void);  


/*========================================================
  [ Dummy function for interrupt ]
  ========================================================*/
void __interrupt		Int_dummy(void){ }
void __interrupt_n		Int_n_dummy(void){ }

/*========================================================
  [ Implement interrupt function]
  ========================================================*/
void __interrupt Int2(void)
{
	//Add your interrupt handler code here
}    
void __interrupt Int3(void)
{
	//Add your interrupt handler code here
}   
void __interrupt Int4(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntTC00(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntTC01(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntTC02(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntTC03(void)
{
	//Add your interrupt handler code here
}   
//----------<16 bit timer counter interrupt routine>      
/*
 ***************************************************************************
 * NAME				:IntTCA0
 *--------------------------------------------------------------------------
 * MODIFY DATE, by	:2015/06/10, Back
 * DESCRIPTION		:TCA0 interrupt function
 * FUNCTION			:-
 * PARAMETER		:-
 *
 * RETURN VALUE		:-
 *
 ***************************************************************************
 */

void __interrupt IntTCA0(void)
{
	static unsigned char regTA0SR;
	regTA0SR = TA0SR.byte;// read TA0SR
	if((regTA0SR&0x80) == 0x00){//not overflow
		if((regTA0SR&0x01) == 0x01){//TA0CPFB has new data
			pulseWidth = TA0DRB.word;
		}
		if((regTA0SR&0x02) == 0x02){//TA0CPFA has new data
			cycleLength = TA0DRA.word;
		}
	}
	else{//overflow error handle
	}
}

void __interrupt IntRTC(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntADC(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntVLTD(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntRXD1(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntTXD1(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntTBT(void)
{
	//Add your interrupt handler code here
}   
void __interrupt IntWUC(void)
{
	//Add your interrupt handler code here
}  
__asm("_WDTROUTINE:") ;
void __interrupt_n IntWDT(void)
{
	//Add your interrupt handler code here
}    
__asm("_WDTEND:");
__asm("_SWIROUTINE:");
void __interrupt_n IntSWI(void)
{
	//Add your interrupt handler code here
	unsigned char tmp; 
	tmp =*(unsigned char*)(0xf000);
	while(tmp != *(unsigned char*)(0xf000))
	{
		tmp =*(unsigned char*)(0xf000);
		
	}	
	SYSCR2.byte=0x10;	//system clock reset
}      
__asm("_SWIEND:") ;
/*============================================
  [ Define interrupt table ]
    This part must be rewrite.
  ============================================*/
#pragma section const INT_VECTOR1
void * const IntTbl1[] = {
    IntTC03,			/* 0xffcc : IntTC03 */
    IntTC02,			/* 0xffce : IntTC02 */
    IntTXD1,			/* 0xffd0 : IntTXD1 */
    IntRXD1,			/* 0xffd2 : IntRXD1 */
    Int_dummy,			/* 0xffd4 : Reserved */	
    Int4,				/* 0xffd6 : Int4 */
    Int3,				/* 0xffd8 : Int3 */
    Int2,				/* 0xffda : Int2 */
    Int_dummy,			/* 0xffdc : Reserved */
    Int_dummy,			/* 0xffde : Reserved */
    Int_dummy,			/* 0xffe0 : Reserved */
    IntTCA0,			/* 0xffe2 : IntTCA0  */
    IntTC01,			/* 0xffe4 : IntTC01 */
    IntTC00,			/* 0xffe6 : IntTC00 */
    IntRTC,				/* 0xffe8 : IntRTC */
    IntADC,				/* 0xffea : IntADC */
    IntVLTD,			/* 0xffec : IntVLTD */
    Int_dummy,			/* 0xffee : Reserved */
    Int_dummy,			/* 0xfff0 : Reserved */
    Int_dummy,			/* 0xfff2 : Reserved */
    IntTBT,				/* 0xfff4 : IntTBT */
    IntWUC,	    		/* 0xfff6 : IntWUC */
    IntWDT,				/* 0xfff8 : IntWDT */
    (void *)0xffff,		/* 0xfffa : Reserved */
    IntSWI,	   			/* 0xfffc : IntSWI/INTUNDEF */     
    startup		    	/* 0xfffe : RESET */					
};
#pragma section const   /* return to default */
